package blatt05;

import blatt05.alphabet.ASCIIAlphabet;
import blatt03.StringDistance;
import blatt05.alphabet.Alphabet;
import blatt05.alphabet.DNAAlphabet;
import blatt05.alphabet.SmallIntegerAlphabet;
import java.io.File;
import java.util.HashMap;

/**
 *
 * @author Nils.Hoffmann@CeBiTec.Uni-Bielefeld.DE
 */
public class QGramDistance implements StringDistance{

    private int q = 1;
    private int sigma = 256;

    private Alphabet a = new ASCIIAlphabet();

    public void setQ(int q) {
        this.q = q;
    }

    public void setSigma(int sigma) {
        this.sigma = sigma;
    }

    public void setAlphabet(Alphabet a) {
        this.a = a;
        this.sigma = a.size();
    }

    public double getDistance(String a, String b) {
        QGramProfile qgp = new DenseQGramProfile(this.sigma,this.q,a,true,this.a);
        qgp.subtractFromProfile(b);
        System.out.println(qgp);
        int qdist = 0;
        for(int i = 0;i<qgp.size();i++) {
            qdist += Math.abs(qgp.getOccurrenceFor(i));
        }
        return qdist;
    }

    public static void main(String[] args) {
        Alphabet sia = new SmallIntegerAlphabet();
        String z = "32671";
        System.out.println("Dense Profile falling:");
        QGramProfile qgp4 = new DenseQGramProfile(sia.size(), 4, z, false, sia);
        System.out.println(qgp4.getWord(3267));
        System.out.println("Dense Profile rising:");
        QGramProfile qgp5 = new DenseQGramProfile(sia.size(), 4, z, true, sia);
        System.out.println(qgp5.getWord(3267));
        System.out.println("Sparse Profile rising:");
        QGramProfile qgp6 = new SparseQGramProfile(sia.size(), 4, z, true, sia);
        System.out.println(qgp5.getWord(3267));
        System.out.println(qgp6.getWord(3267));

        DNAAlphabet dna = new DNAAlphabet();
        FASTAReader fr = new FASTAReader();
        HashMap<String,String> hm = fr.read(new File("xanthomonas.fasta"));
        for(String key:hm.keySet()) {
            for(int i=1;i<=1024;i++) {
                System.out.println("q="+i);
                DenseQGramProfile dqp = new DenseQGramProfile(dna.size(), i, hm.get(key), true, dna);
                SparseQGramProfile sqp = new SparseQGramProfile(dna.size(), i, hm.get(key), true, dna);
            }
        }
    }
}
