package blatt05;

/**
 * Interface for QGramProfile implementations.
 * @author Nils.Hoffmann@CeBiTec.Uni-Bielefeld.DE
 */
interface QGramProfile {
    /**
     * Returns the occurrence of a qgram with index code.
     * @param code
     * @return
     */
    public int getOccurrenceFor(int code);

    /**
     * Subtract the occurrences of qgrams in String b from
     * the current qgram.
     * @param b
     */
    public void subtractFromProfile(String b);

    /**
     * Returns the theoretical number of qgrams.
     * The real number of qgrams in this qgram can be less.
     * @return
     */
    public int size();

    /**
     * Returns the rank associated to the given word of length q.
     * @param word
     * @return
     */
    public int getRank(String word);

    /**
     * Returns the String representation of the
     * q-gram with rank rank.
     * @param rank
     * @return
     */
    public String getWord(int rank);
}
