package blatt05.alphabet;

/**
 *
 * @author Nils.Hoffmann@CeBiTec.Uni-Bielefeld.DE
 */
public class ASCIIAlphabet implements Alphabet{
    private char[] asciiTable = new char[256];

    public ASCIIAlphabet() {
        for(int i=0;i<asciiTable.length;i++) {
                asciiTable[i] = (char)i;
        }
    }

    public int toCode(String a) {
        if(a.length()>1) {
            throw new IllegalArgumentException("Only one-letter Strings can be used!");
        }
        return (int)a.charAt(0);
    }

    public String toSymbol(int code) {
        return String.valueOf(this.asciiTable[code]);
    }

    public int size() {
        return asciiTable.length;
    }
}
